<Query Kind="Statements" />


    // Deklaration af variabler
    string ProduktId, VariantId, Antal, Pris, VareNr, Titel, Notifikation, HemmeligNoegle, Domaene, Protokol;

    /*** START ***/
    // 1. Indsæt dine parameterværdier mellem anførselstegnene:
    ProduktId = "110";
    VareNr = "A001";
    VariantId = "5";
    Titel = "Tilbud ifølge aftale";
    Pris = "99";
    Antal = "3";
    Notifikation = "Nej";
    // Bemærk: Undlad værdier til parametre du ikke ønsker medtaget i linket ("")

    // 2. Indsæt din hemmelige nøgle fra shoppen mellem anførselstegnene:
    HemmeligNoegle = "hemmelig";

    // 3. Indsæt dit domæne mellem anførselstegnene:
    Domaene = "minshop.dk";

    // 4. Hvis du benytter SSL kan du lade følgende værdi være.
    // Og hvis ikke skal den ændres til "http://", altså uden "s":
    Protokol = "https://";

    // 5. Tast F5 på dit tastatur eller klik på "play knappen" i topmenuen af LINQPad
    // -herefter køres koden og det genererede link vises i "Results" vinduet herunder.
    /*** SLUT ***/

    // Koden herunder håndterer validering og konvertering af værdier til SHA-1, samt opbygning af komplet URL
    // (reference til System.Web.dll (HttpUtility) udeladt for umiddelbar afvikling i LINQPad)
    System.Collections.Specialized.NameValueCollection args = new System.Collections.Specialized.NameValueCollection();
    if (!string.IsNullOrEmpty(ProduktId)) args.Add("product", ProduktId);
    if (!string.IsNullOrEmpty(VareNr)) args.Add("sku", VareNr);
    if (!string.IsNullOrEmpty(VariantId)) args.Add("variant", VariantId);
    if (!string.IsNullOrEmpty(Titel)) args.Add("title", Titel);
    if (!string.IsNullOrEmpty(Pris)) args.Add("price", Pris);
    if (!string.IsNullOrEmpty(Antal)) args.Add("amount", Antal);
    if (!string.IsNullOrEmpty(Notifikation)) {args.Add("notification", (Notifikation == "Nej") ? "false":"true");}
    args.Add("code", ""); // Benyttes til SHA-1
    HemmeligNoegle += string.Join("", args.AllKeys.Select(key => args[key]));
    string hash = System.Security.Cryptography.SHA1.Create().ComputeHash(
        Encoding.UTF8.GetBytes(HemmeligNoegle)).Aggregate(string.Empty, (x, y) => x + y.ToString("x2"));
    IEnumerable<string>
        segments = from key in args.AllKeys
        from value in args.GetValues(key)
        select string.Format("{0}={1}",
		System.Net.WebUtility.UrlEncode(key),
		System.Net.WebUtility.UrlEncode(value));
string url = Protokol + (Domaene = Domaene.Replace("/", "")) + "/actions/cart/add/?" + string.Join("&", segments) + hash;
url.Dump();
